**********************************************************************
* Program....: CompStru
* Compiler...: Visual FoxPro 06.00.8492.00 for Windows
* Abstract...: Compares the structure of two tables
**********************************************************************
FUNCTION CompStru( tcFile1, tcFile2 )
LOCAL ARRAY laFields[1]
LOCAL lnSelect, lnCnt, lcFile, llRetVal 

*** Save current work area
lnSelect = SELECT()
SELECT 0
*** Create a temporary cursor for comparing structures
CREATE CURSOR tmpstru ( ;
    fname C(60), ftype C(1), flen N(3,0), fdec N(3,0), fnul L(1) )
*** Open the files to compare and get their structures into the cursor
FOR lnCnt = 1 TO 2
    lcFile = ("tcFile" + PADL(lnCnt,1))
    USE (&lcFile) AGAIN IN 0 SHARED ALIAS TestFile
    AFIELDS( laFields, 'TestFile' )
    APPEND FROM ARRAY laFields
    USE IN TestFile
NEXT
*** Now see if the fields are identical
SELECT *, COUNT(*) cnt ;
  FROM tmpstru ;
  GROUP BY fname, ftype, flen, fdec, fnul ;
  HAVING cnt # 2 ;
  INTO ARRAY junk
  
*** Tidy up and Return Logical T/F if structure is identical
llRetVal = (_TALLY = 0)
SELECT (lnSelect)
USE IN tmpstru
RETURN llRetVal
